part of 'application.dart';

class _AppBindingObserver extends WidgetsBindingObserver {
  final ApplicationState _app;

  _AppBindingObserver(this._app) {
    WidgetsBinding.instance!.addObserver(this);
  }

  @override
  void didChangeMetrics() => _app.isInputMethodVisible.value = WidgetsBinding.instance!.window.viewInsets.bottom > 0;

  @override
  Future<bool> didPushRoute(String route) => _app._appRouterDelegate.didPushRoute(route);

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) => _app.lifecycle.value = state;

  void dispose() => WidgetsBinding.instance!.removeObserver(this);
}
